// Code generated by Wire. DO NOT EDIT.

//go:generate wire
//+build !wireinject

package main

import (
	"github.com/sirupsen/logrus"
	"gitlab.com/smotrova-otus/ls-social-network/socialnetwork/auth"
	"gitlab.com/smotrova-otus/ls-social-network/socialnetwork/config"
	"gitlab.com/smotrova-otus/ls-social-network/socialnetwork/passwordhash"
	"gitlab.com/smotrova-otus/ls-social-network/socialnetwork/pkg/clock"
	auth2 "gitlab.com/smotrova-otus/ls-social-network/socialnetwork/pkg/middleware/auth"
	"gitlab.com/smotrova-otus/ls-social-network/socialnetwork/pkg/middleware/auth/token"
	"gitlab.com/smotrova-otus/ls-social-network/socialnetwork/pkg/uuid"
	"gitlab.com/smotrova-otus/ls-social-network/socialnetwork/profile"
)

import (
	_ "github.com/go-sql-driver/mysql"
)

// Injectors from wire.go:

func NewContainer(cfg2 *config.Config, logger2 *logrus.Entry, masterConn2 *MasterConnection, slaveConn2 *SlaveConnection) *Container {
	jwtStrategyConfig := provideJwtStrategyConfig(cfg2)
	realClock := clock.NewRealClock()
	serviceJwt := token.NewJwtService(jwtStrategyConfig, realClock)
	accountRepositoryImpl := auth.NewAccountRepository(masterConn2)
	passwordHasherImpl := passwordhash.NewPasswordHasherImpl()
	generatorImpl := uuid.NewGeneratorImpl()
	service := auth.NewService(serviceJwt, accountRepositoryImpl, passwordHasherImpl, generatorImpl)
	endpointParams := auth2.EndpointParams{
		JWTStrategyConfig: jwtStrategyConfig,
	}
	endpoints := auth.MakeServerEndpoints(service, endpointParams)
	httpHandlerParams := auth.HTTPHandlerParams{
		Logger: logger2,
	}
	httpHandlerSet := auth.NewHTTPHandlerSet(endpoints, httpHandlerParams)
	repositoryImpl := profile.NewProfileRepository(masterConn2, slaveConn2)
	profileService := profile.NewService(repositoryImpl, generatorImpl)
	profileEndpoints := profile.MakeServerEndpoints(profileService, endpointParams)
	profileHTTPHandlerParams := profile.HTTPHandlerParams{
		Logger: logger2,
	}
	profileHTTPHandlerSet := profile.NewHTTPHandlerSet(profileEndpoints, profileHTTPHandlerParams)
	container := &Container{
		AuthHTTPHandlerSet:    httpHandlerSet,
		ProfileHTTPHandlerSet: profileHTTPHandlerSet,
	}
	return container
}

// wire.go:

func provideJwtStrategyConfig(cfg2 *config.Config) token.JWTStrategyConfig {
	return token.JWTStrategyConfig{
		Key:      []byte(cfg2.Auth.Key),
		Ttl:      cfg2.Auth.Ttl,
		Audience: cfg2.Auth.Audience,
		Issuer:   cfg2.Auth.Issuer,
	}
}
